/*
 * force.h
 *
 *  Created on: Oct 9, 2012
 *      Author: crtrott
 */

#ifndef FORCE_H_
#define FORCE_H_

#include "ljs.h"
#include "atom.h"
#include "neighbor.h"
#include "comm.h"

class Force
{
  public:
    MMD_float cutforce;
    MMD_float cutforcesq;
    MMD_float eng_vdwl;
    MMD_float mass;
    MMD_int evflag;
    MMD_float virial;
    MMD_int ghost_newton;

    Force() {};
    virtual ~Force() {};
    virtual void setup() {};
    virtual void finalise() {};
    virtual void compute(Atom &, Neighbor &, Comm &, int) {};

    int use_sse;
    int use_oldcompute;
    ThreadData* threads;
    MMD_int reneigh;
    Timer* timer;


    ForceStyle style;
  protected:

    MMD_int me;
    MMD_int nlocal, nmax;
    tvector_2d x, f;
    tvector_1i numneigh;                   // # of neighbors for each atom
    tvector_neighbors neighbors;                  // array of neighbors of each atom
    MMD_int maxneighs;
};

struct ForceZeroFunctor {
  typedef tvector_2d::device_type  device_type ;
  typedef tvector_2d::value_type 	MMD_float;
  typedef tvector_1i::size_type    MMD_int;

  tvector_2d f;

  KOKKOSARRAY_INLINE_FUNCTION
  void operator()(const MMD_int i) const {
    f(i, 0) = 0;
    f(i, 1) = 0;
    f(i, 2) = 0;
  }
};

#endif /* FORCE_H_ */
