/*
 * atom_kernel.h
 *
 *  Created on: Jan 19, 2012
 *      Author: ctrott
 */
#include "precision.h"
//#define MMD_floatK3 float3;
//#define MMD_float float;

__kernel void atom_pack_comm(__global MMD_floatK3* x, __global MMD_float* buf, __global int* list, int offset, MMD_floatK3 pbc, int n)
{
	  list += offset;
	  int j = get_global_id(0);
	  if(j<n)
	  {
		  int i=list[j];
		  MMD_floatK3 xi=x[i]+pbc;
		  buf[3*j]=xi.x;
		  buf[3*j+1]=xi.y;
		  buf[3*j+2]=xi.z;
	  }
}

__kernel void atom_unpack_comm(__global MMD_floatK3* x, __global MMD_float* buf, int first, int n)
{
	  int i = get_global_id(0);
	  if(i<n)
	  {
		  MMD_floatK3 xi;
		  xi.x=buf[3*i];
		  xi.y=buf[3*i+1];
		  xi.z=buf[3*i+2];
		  x[i+first]=xi;

	  }

}

__kernel void atom_comm_self(__global MMD_floatK3* x, __global int* list, int offset, MMD_floatK3 pbc, int first, int n)
{
	  list += offset;
	  int j = get_global_id(0);
	  if(j<n)
	  {
		  int i=list[j];
		  x[j+first] = x[i]+pbc;

	  }


}

