/*
 * integrate_kernel.h
 *
 *  Created on: Jan 19, 2012
 *      Author: ctrott
 */

//#define MMD_floatK float
//#define MMD_floatK3 float3
//#define MMD_floatK3 float3;
//#define MMD_float float;

#include "precision.h"

__kernel void integrate_initial(__global MMD_floatK3* x, __global MMD_floatK3* v,__global MMD_floatK3* f, int nlocal, MMD_float dt,MMD_float dtforce,int nmax)
{
  int i = get_global_id(0);
  if(i<nlocal)
  {
	  v[i] += dtforce*f[i];
	  x[i] += dt*v[i];
  }
}

__kernel void integrate_final(__global MMD_floatK3* v, __global MMD_floatK3* f, int nlocal, MMD_float dt,int nmax)
{
  int i = get_global_id(0);
  if(i<nlocal)
  {
	  v[i] += dt*f[i];
  }

}

