/*
 * neighbor_kernel.h
 *
 *  Created on: Jan 20, 2012
 *      Author: ctrott
 */

#include "precision.h"
//#define MMD_floatK3 float3;
//#define MMD_float float;
/*
int coord2bin(MMD_floatK3 &x,MMD_floatK3 &bininv, MMD_floatK3 &prd, int3 &mbinlo, int3 &nbin, int3 &mbin)
{
	int ix = (int) ((x.x-(x.x>=prd.x)*prd.x)*bininv.x) + nbin.x - mbinlo.x - (x.x<0.0):
    int iy = (int) ((x.y-(x.y>=prd.y)*prd.y)*bininv.y) + nbin.y - mbinlo.y - (x.y<0.0):
    int iz = (int) ((x.z-(x.z>=prd.z)*prd.z)*bininv.z) + nbin.z - mbinlo.z - (x.z<0.0):
						  ;
	return (iz*mbin.y*mbin.x + iy*mbin.x + ix + 1);
}*/

__kernel void neighbor_build(__global MMD_floatK3* x, __global int* numneigh, __global int* neighbors,
		__global int* bincount, __global int* bins, __global int* ibins, __global int* flag,
		__global int* stencil, int nstencil, MMD_float cutneighsq, int atoms_per_bin, int maxneighs, int nlocal)//,MMD_floatK3 &bininv, MMD_floatK3 prd, int3 &mbinlo, int3 nbin, int3 mbin)
{

	int i = get_global_id(0);
	if(i>=nlocal) return;
	int ibin = ibins[i];
	MMD_floatK3 xtmp = x[i];
	int n = 0;
	for(int k = 0; k < nstencil; k++)
	{
		int jbin = ibin + stencil[k];
	    for(int m=0;m<bincount[jbin];m++)
	    {
	      int j = bins[jbin*atoms_per_bin+m];
	      MMD_floatK3 del = xtmp - x[j];
	      MMD_float rsq = del.x*del.x + del.y*del.y + del.z*del.z;
	      if ((rsq <= cutneighsq)&&(j!=i)) neighbors[i+n++*nlocal] = j;

	    }

	}

	numneigh[i] = n;
	if(n>maxneighs)
	  	flag[0] = 1;

}


__kernel void neighbor_bin(__global MMD_floatK3* xg, __global int* bincount, __global int* bins,
		__global int* ibins, __global int* flag, int atoms_per_bin, int nall,
		MMD_floatK3 bininv, MMD_floatK3 prd, int3 mbinlo, int3 nbin, int3 mbin)
{
	int i = get_global_id(0);
	if(i>=nall) return;
	MMD_floatK3 x = xg[i];
	/*  int ix;
	  if (x.x >= prd.x)
	    ix = (int) ((x.x-prd.x)*bininv.x) + nbin.x - mbinlo.x;
	  else if (x.x >= 0.0)
	    ix = (int) (x.x*bininv.x) - mbinlo.x;
	  else
	    ix = (int) (x.x*bininv.x) - mbinlo.x - 1;
	  int iy;
	  if (x.y >= prd.y)
	    iy = (int) ((x.y-prd.y)*bininv.y) + nbin.y - mbinlo.y;
	  else if (x.y >= 0.0)
	    iy = (int) (x.y*bininv.y) - mbinlo.y;
	  else
	    iy = (int) (x.y*bininv.y) - mbinlo.y - 1;
	  int iz;
	  if (x.z >= prd.z)
	    iz = (int) ((x.z-prd.z)*bininv.z) + nbin.z - mbinlo.z;
	  else if (x.z >= 0.0)
	    iz = (int) (x.z*bininv.z) - mbinlo.z;
	  else
	    iz = (int) (x.z*bininv.z) - mbinlo.z - 1;*/
	int3 doit = x>=prd;
	int ix = (int) ((x.x-(x.x>=prd.x)*prd.x)*bininv.x) - nbin.x*doit.x - mbinlo.x - (x.x<0.0);
    int iy = (int) ((x.y-(x.y>=prd.y)*prd.y)*bininv.y) - nbin.y*doit.y - mbinlo.y - (x.y<0.0);
    int iz = (int) ((x.z-(x.z>=prd.z)*prd.z)*bininv.z) - nbin.z*doit.z - mbinlo.z - (x.z<0.0);
						  ;
	int ibin = (iz*mbin.y*mbin.x + iy*mbin.x + ix + 1);
	//int ibin = coord2bin(x[i],bininv,prd,mbinlo,nbin,mbin);
	ibins[i] = ibin;
	int pos = atomic_add(&bincount[ibin],1);
	if(pos<atoms_per_bin) bins[ibin*atoms_per_bin+pos]=i;
	else flag[0]=1;


}

