/*
 * precision.h
 *
 *  Created on: Jan 19, 2012
 *      Author: ctrott
 */

#ifndef PRECISION_H_
#define PRECISION_H_

#ifndef IAMONDEVICE
#include <CL/cl.h>
#endif
#ifndef MDPREC
#define MDPREC 2
#endif
#if MDPREC == 2
#pragma OPENCL EXTENSION cl_khr_fp64
#ifndef double3
struct sdouble3{
 double x;
 double y;
 double z;
};
typedef struct sdouble3 double3;
#endif

#ifndef double4
struct sdouble4{
 double x;
 double y;
 double z;
 double w;
};
typedef struct sdouble4 double4;
#endif

typedef cl_double3 MMD_float3;
typedef cl_double4 MMD_float4;


typedef double3 MMD_floatK3;
typedef double4 MMD_floatK4;
typedef double MMD_float;
#define F(a) a

#endif //MDPREC == 2

#if MDPREC == 1

#ifndef float3
struct sfloat3{
 float x;
 float y;
 float z;
};
#ifndef IAMONDEVICE
typedef struct sfloat3 float3;
#endif
#endif

#ifndef float4
struct sfloat4{
 float x;
 float y;
 float z;
 float w;
};
#ifndef IAMONDEVICE
typedef struct sfloat4 float4;
#endif
#endif

#ifndef IAMONDEVICE
typedef cl_float3 MMD_float3;
typedef cl_float4 MMD_float4;
#endif
typedef float3 MMD_floatK3 ;
typedef float4 MMD_floatK4 ;
typedef float MMD_float;
#define F(a) a.f

#endif //MDPREC == 1

#ifndef PRECMPI
#define PRECMPI MPI_DOUBLE
#endif

#endif /* PRECISION_H_ */
